@echo off
rem REVERT-4.1.2-patch1_de.bat 1.0.0  UTF-8                       2016-08-21
rem -----1---------2---------3---------4---------5---------6---------7-------*
rem 
rem Licensed to the Apache Software Foundation (ASF) under one
rem or more contributor license agreements.  See the NOTICE file
rem distributed with this work for additional information
rem regarding copyright ownership.  The ASF licenses this file
rem to you under the Apache License, Version 2.0 (the
rem "License"); you may not use this file except in compliance
rem with the License.  You may obtain a copy of the License at
rem
rem  http://www.apache.org/licenses/LICENSE-2.0
rem
rem Unless required by applicable law or agreed to in writing,
rem software distributed under the License is distributed on an
rem "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
rem KIND, either express or implied.  See the License for the
rem specific language governing permissions and limitations
rem under the License.
rem
rem -----1---------2---------3---------4---------5---------6---------7-------*

rem KUENDIGE DIESES SKRIPT AN
TITLE APACHE OPENOFFICE 4.1.2-PATCH1 PROZESS
COLOR 71
rem   Hell-weisser Hintergrund mit blauem Text
CLS
ECHO:
ECHO * 1.0.0 DEINSTALLIEREN VON 4.1.2-PATCH1 VON APACHE OPENOFFICE 4.1.2

rem VERIFIZIERE SKRIPT IM GLEICHEN VERZEICHNIS (%~dp0) ALS DIE 
rem AUSGEPACKTE ZIP-DATEI
IF NOT EXIST "%~dp0LICENSE.txt" GOTO :FAIL1
IF NOT EXIST "%~dp0NOTICE.txt" GOTO :FAIL1
IF NOT EXIST "%~dp0README-4.1.2-patch1-Windows_de.txt" GOTO :FAIL1
IF NOT EXIST "%~dp0APPLY-4.1.2-patch1_de.bat" GOTO :FAIL1
IF NOT EXIST "%~dp0tl.dll.new" GOTO :FAIL1
IF NOT EXIST "%~dp0tl.dll.new.asc" GOTO :FAIL1
IF NOT EXIST "%~dp0tl.dll.old" GOTO :FAIL1
IF NOT EXIST "%~dp0tl.dll.old.asc" GOTO :FAIL1

rem BERICHTE EINEN NEUSTART
IF NOT DEFINED AOOPATCH GOTO :LOCATE
ECHO:        Ein vorheriger Patch-Prozess wurde eventuell abgebrochen.

:LOCATE
rem LOKALISIERE X86 PROGRAMM-DATEIEN
SET AOOPATCH=%ProgramFiles%
IF DEFINED ProgramFiles(x86) SET AOOPATCH=%ProgramFiles(x86)%

rem FINDE APACHE OPENOFFICE
SET AOOPATCH=%AOOPATCH%\OpenOffice 4\program
IF NOT EXIST "%AOOPATCH%\soffice.exe" GOTO :FAIL2
ECHO:        Gefunden in %AOOPATCH%
ECHO:        Bitte warten. Dateien werden geprueft ...
IF EXIST "%AOOPATCH%\hwp.dll" GOTO :FAIL2

rem    Apache OpenOffice 4.x.x ohne die Datei "hwp.dll" entdeckt. Es ist
rem    wahrscheinlich 4.1.2, obwohl es auch eine andere sein kann, bei der
rem    "hwp.dll" vom Benutzer geloescht wurde. Es koennte auch eine Version
rem    vor 4.1.2 sein. Der Punkt ist, ob der Patch "4.1.2-patch1" angewendet
rem    wurde.

rem VERIFIZIERE, DASS TL.DLL EXISTIERT
IF NOT EXIST "%AOOPATCH%\tl.dll" GOTO :NODLL

rem PRUEFE, OB TL.DLL SCHON GEPATCHT IST
FC /B "%AOOPATCH%\tl.dll" "%~dp0tl.dll.new" >NUL
IF NOT ERRORLEVEL 1 GOTO :PATCHED

rem OPENOFFICE IST NICHT GEPATCHT
ECHO:
ECHO:        Der 4.1.2-PATCH1 ist nicht vorhanden.
ECHO:
ECHO:        Es wurden keine Aenderungen gemacht.
GOTO :CLEAN

:PATCHED
ECHO:        4.1.2-patch1 wurde in Datei "tl.dll" gefunden.
GOTO :REVERT

:NODLL
rem ES GIBT KEINE TL.DLL. ES IST ENTWEDER UNNOETIG ODER ES GAB EIN PROBLEM.
ECHO:        Datei "tl.dll" wurde nicht gefunden.

:REVERT
rem BENUTZE TL.DLL.OLD, WENN VORHANDEN, SONST BENUTZE DIE ORIGINALE VON 4.1.2
IF NOT EXIST "%AOOPATCH%\tl.dll.old" GOTO :RESETOLD
ECHO:        Datei "tl.dll.old" gefunden, wird wiederhergestellt.
GOTO :RESTORE

:RESETOLD
COPY /B "%~dp0tl.dll.old" "%AOOPATCH%\tl.dll.old" >NUL 2>&1
IF ERRORLEVEL 1 GOTO :FAIL3
rem ERZWINGE EINEN SAUBERES WIEDERHERSTELLEN
ECHO:        Es gibt keine Datei "tl.dll.old" als Backup.
ECHO:        Stelle die originale Datei "tl.dll" von Version 4.1.2.

:RESTORE
MOVE /Y "%AOOPATCH%\tl.dll.old" "%AOOPATCH%\tl.dll" >NUL 2>&1
IF ERRORLEVEL 1 GOTO :FAIL3

rem UMBENENNEN ERFOLGREICH
ECHO:        Die Datei "tl.dll" wurde wiederhergestellt.
ECHO:
ECHO:        Der Patch "4.1.2-PATCH1" wurde erfolgreich deinstalliert.

:CLEAN
ECHO:
ECHO         Um den Patch zu installieren, benutze die Batch-Datei
ECHO         "APPLY-4.1.2-patch1_de.bat" wie beschrieben in der Datei 
ECHO         "README-4.1.2-patch1-Windows_de.txt".

:LEAVE
ECHO:
ECHO:
SET AOOPATCH=
PAUSE
EXIT /B 0


:FAIL1
ECHO:
ECHO * ***** Dieses Patch-Skript ist nicht im richtigen Verzeichnis.
ECHO *       "REVERT-4.1.2-patch1_de.bat" muss in dem Verzeichnis sein, in dem
ECHO *       "apache-openoffice-4.1.2-patch1-Win_x86_de.zip" ausgepackt wurde.
ECHO *       Es ist nicht vorgesehen, dass das Skript getrennt davon
ECHO *       funktioniert.
ECHO *
ECHO *       Folge den Schritten in der Datei
ECHO *       "README-4.1.2-patch1-Windows_de.txt", um das richtige 
ECHO *       Verzeichnis zu erstellen, dass dieses Skript enthaelt.

:BAIL
COLOR 74
rem   Hell-weisser Hintergrund und roter Text
ECHO:
ECHO:
SET AOOPATCH=
PAUSE
EXIT /B 2

:FAIL2
ECHO:
ECHO * ***** Apache OpenOffice 4.1.2 wurde nicht gefunden
ECHO *       Eine geeignete Version von Apache OpenOffice wurde nicht im
ECHO *       erwarteten Verzeichnis entdeckt.
ECHO *       
ECHO *       Es wurden keine Aenderungen gemacht.
ECHO *       
ECHO *       Das Patch-Skript wurde noch nicht angewendet. Falls stattdessen
ECHO *       ein manueller Prozess verwendet wurde, muss die Datei "tl.dll" 
ECHO *       ebenfalls manuell wiederhergestellt werden.
GOTO :BAIL

:FAIL3
ECHO:
ECHO * ***** Administrator-Rechte benoeigt
ECHO *       Dieses Batch-Skript "REVERT-4.1.2-patch1_de.bat" muss mit der 
ECHO *       Option "Als Administrator" gestartet werden, falls verfuegbar.
ECHO *       Auf Windows XP, starte das Skript mit einem Benutzerkonto, das
ECHO *       Administrator-Rechte besitzt.

ECHO *       Siehe die Datei "README-4.1.2-patch1-Windows_de.txt" fuer 
ECHO *       weitere Details.
ECHO *       
ECHO *       Es wurden keine Aenderungen gemacht.
GOTO :BAIL

rem              *** Ende von REVERT-4.1.2-patch1_de.bat ***